package org.apache.commons.ognl.internal.entry;

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information       
 * regarding copyright ownership.  The ASF licenses this file  
 * to you under the Apache License, Version 2.0 (the           
 * "License"); you may not use this file except in compliance  
 * with the License.  You may obtain a copy of the License at  
 *                                                             
 *   http://www.apache.org/licenses/LICENSE-2.0                
 *                                                             
 * Unless required by applicable law or agreed to in writing,  
 * software distributed under the License is distributed on an 
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY      
 * KIND, either express or implied.  See the License for the   
 * specific language governing permissions and limitations     
 * under the License.
 */

/*
 * $Id$
 */

import java.lang.reflect.Method;
import java.lang.reflect.Modifier;

/**
 * User: mcucchiara
 * Date: 13/10/11
 * Time: 13.00
 */
public class DeclaredMethodCacheEntryFactory
    extends MethodCacheEntryFactory<DeclaredMethodCacheEntry>
{
    @Override
    protected boolean shouldCache( DeclaredMethodCacheEntry key, Method method )
    {
        if ( key.type == null )
        {
            return true;
        }
        else
        {
            boolean isStatic = Modifier.isStatic( method.getModifiers() );
            if ( key.type == DeclaredMethodCacheEntry.MethodType.STATIC )
            {
                return isStatic;
            }
            else
            {
                return !isStatic;
            }
        }

    }
}
