package org.apache.commons.ognl;

/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

/**
 * OGNL stands for Object-Graph Navigation Language; it is an expression language
 * for getting and setting properties of Java objects. You use the same expression
 * for both getting and setting the value of a property.
 *
 * OGNL started out as a way to set up associations between UI
 * components and controllers using property names.  As the desire for
 * more complicated associations grew, Drew Davidson created what he
 * called KVCL, for Key-Value Coding Language, egged on by Luke
 * Blanshard.  Luke then reimplemented the language using ANTLR, came up
 * with the new name, and, egged on by Drew, filled it out to its current
 * state.
 *
 * We pronounce OGNL as a word, like the last syllables of a drunken
 * pronunciation of "orthogonal" or like "ogg-null".
 * $Id$
 */

